#import os
import math
from vec3 import Vec3
from frame import Frame
#os.chdir(os.path.join('C:\\', 'Users', 'gb2', 'Documents', 'PhD', 'Python'))


class Viewpoint:
    def __init__(self, landscape, pose):
        self._frame = Frame.universal()
        self.landscape = landscape
        self.pose = pose
        self.pose.parentFrame = self._frame

    def setLocation(self, latitude, longitude, altitude):
        frame = self.landscape.sphericalToCart(latitude, longitude, altitude, returnAsLocalFrame=True)
        self.position = frame.origin
        self._frame.axes = frame.axes
        self.pose.position = self.position
        self.pose.parentFrame = self._frame
        return None

    @property
    def position(self):
        return self._frame.origin

    @position.setter
    def position(self, newPosition):
        self._frame.origin = newPosition
        self.pose.position = newPosition
        self.pose.parentFrame = self._frame

    @property
    def frame(self):
        return self._frame

    @frame.setter
    def frame(self, newFrame):
        self._frame = newFrame
        self.pose.parentFrame = self._frame

    